
// For ATtiny2313!

// USART definitions
#define USART_BAUDRATE 9600 
#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)
#define BUFFERSIZE 32		// Keep below 127. Watch data memory consumption!

#include <avr/io.h>
#include <avr/interrupt.h>

volatile uint8_t usartBuffer[BUFFERSIZE];	// FIFO stack
volatile uint8_t writeIndex, currentIndex;


// Initialize USART Module
void USART_Init(void);
// Send a single byte over USART
void sendUSARTbyte(uint8_t data);
// Gets the most recent element from the buffer
uint8_t popFromBuffer(void);
// Read an element from the buffer, but don't pop it
uint8_t peekFromBuffer(void);
// Add a new element to the buffer
void bufferInsert(uint8_t data);
// Send a character string over serial
void sendSerialString(char stringData[]);
